//////////////////////////////////////////////////////////////////////////
//Trooper119's 3D spawn code//////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////
/******************************************************************************
**Before the level loads, if you wish, "max_entities = #" must be defined 
**(or defining nexus by a -nx command) so that NEXUS times 10 is not the maxiumum
**number of entities that can be contained in your level(s) (its usually set
**at a max of 300 when it hasn't been tampered with)
*******************************************************************************
**To quote the manuel "The random sequence starts always with the same numbers, 
**unless 'randomized' at game start by randomize()." In short, put in
**"randomize()" in the "main" function to truely get random positions
******************************************************************************/
//Simply plug in actions spawn_cylinder, spawn_circle_half, spawn_circle_full, spawn_circle_plane, spawn_square_full, or spawn_square_plane and enter their corresponding limits (side or radius length, among others) and your entities, with the action defined here, will be spawned

						 ////DEFINING ENTITIES////
//Note: You define the unique entities in the 1st function from top and corresponding actions in the 2nd function from top
//Note: if you define corresponding actions you must remove "//" from the called function and remove ent_create("","", action action_switch) that exists (only if you define unique actions)
string create_entity1 = <guard.mdl>;	//define entities wanted here, plug them in "function select_spawned" (1st function)
string create_entity2 = <fish.mdl>;
string create_entity3 = <explo+7.pcx>;
string create_entity4 = <glow+4.pcx>;
string create_entity5 = <detail.pcx>;
string create_entity6 = null;


						     ////DIMENSIONS////
DEFINE	_radius, SKILL1;
DEFINE	_height_length, SKILL2;
DEFINE	_base_length_x, SKILL3;
DEFINE	_base_length_y, SKILL4;

						 ////SPAWNING PARAMETERS////
DEFINE	_local_kill_limit, SKILL5;	//sets the number of kills needed (locally) before this spawner turns off
DEFINE	_global_limit, SKILL6;		//limit of how many entities can exhist (in this level) by the collective random spawns
					//Note: If more than one number exhists in global random spawns, it takes the highest value
DEFINE	_local_limit, SKILL7;		//limit of how many entities can exhist (in this level) by this random spawn
DEFINE	pan_angle, SKILL8;		//sets the starting pan of each  entity, (this changes if the _random_pan, flag is set)
DEFINE	tilt_angle, SKILL9;		//sets the starting tilt of each entity, (this changes if the _random_tilt, flag is set)
DEFINE	roll_angle, SKILL10;		//sets the starting roll of each  entity, (this changes if the _random_roll, flag is set)
DEFINE	_spawn_delay, SKILL11;		//this sets the number of frames between spawns on each spawner (default 1 frame)
DEFINE	_starting_ent, SKILL12;		//starting number of entity to be spawned
DEFINE	_ending_ent, SKILL13;		//ending number of entity to be spawned

						////SPAWN HOLDERS////ALL BUT ADVANCED USERS: DO NOT TAMPER////
DEFINE	_amount_created, SKILL34;
DEFINE	spawn_state, SKILL35;		//holder for current spawn3D state
DEFINE	_handle_id, SKILL36;		//holder for each handle number
DEFINE	_local_kills, SKILL37;		//current kills done against this spawner
DEFINE	_temp_global, SKILL38;
DEFINE	_temp_local, SKILL39;
DEFINE	temp_create_num, SKILL40;	//holder for current entity being spawned

							////FLAGS////
DEFINE	_random_pan, FLAG1;		//if on, entity has random pan angle at creation
DEFINE	_random_tilt, FLAG2;		//if on, entity has random tilt angle at creation
DEFINE	_random_roll, FLAG3;		//if on, entity has random roll angle at creation
DEFINE	_ignore_global, FLAG4;		//if on, ignores the global limit set by any spawn
DEFINE	_ignore_local, FLAG5;		//if on, ignores the local limit assigned by this spawn
DEFINE	_x_axis, FLAG6;			//if on, object's base(s) will lie along the x axis
DEFINE	_y_axis, FLAG7;			//if on, object's base(s) will lie along the y axis
DEFINE	_go_limit_once, FLAG8;		//if on, spawner spawns until it reaches one of its limits, only once, then stops

						   ////SPAWN3D STATES////
DEFINE	spawn_stop,0;
DEFINE	spawn_start,1;


//Define flag of go to spawn limit, then stop for good
					       ////VARIABLES FOR FUNCTIONS////
var temp_create_num;
string* created_entity;			//temporary entity holder

var global_spawn_limit = 0;
var global_count = 0;
var temp_creation[3];
entity* spawn_pointer;
entity* temp_ent_switch;

var temp_move[3];		//for spawn function
var stuck_yet;

var creation_point[3];		//for the position functions
var creation_maxrange[3];
var axis_switch[3];

var spawnhandle_counter = 0;
var spawnhandle_array[100];		//maximum number of spawners is 100 right now (you can change this number for more)

var handle_ident;		//when spawners are scanned this entity stores what handleid they have

entity* this_spawn;		//current spawner is stored here with call of access_3dspawn(3d_spawner); function
entity* death_spawn_update;	//temporary holder, ignore this


function select_spawned(temp_create)		//Define corresponding list of entities as shown below if want to expand
{
	if (temp_create == 1) { created_entity = create_entity1; }
	if (temp_create == 2) { created_entity = create_entity2; }
	if (temp_create == 3) { created_entity = create_entity3; }
	if (temp_create == 4) { created_entity = create_entity4; }
	if (temp_create == 5) { created_entity = create_entity5; }
	if (temp_create == 6) { created_entity = create_entity6; }
}

function corresponding_actions(temp_action)
{
	if (temp_action == 1) { temp_ent_switch = ent_create (created_entity, creation_point, actor_walk_fight); }
	if (temp_action == 2) { temp_ent_switch = ent_create (created_entity, creation_point, actor_walk_fight); }
	if (temp_action == 3) { temp_ent_switch = ent_create (created_entity, creation_point, actor_ai_one); }
	if (temp_action == 4) { temp_ent_switch = ent_create (created_entity, creation_point, actor_ai_one); }
	if (temp_action == 5) { temp_ent_switch = ent_create (created_entity, creation_point, actor_ai_one); }
	if (temp_action == 6) { temp_ent_switch = ent_create (created_entity, creation_point, null); }
}


action action_switch
{
	my.visible = off;
	creation_point.x = my.x;
	creation_point.y = my.y;
	creation_point.z = my.z;			
	temp_move.x = creation_point.x + (my.max_x - my.min_x) + 1;
	temp_move.y = creation_point.y;		//trace will end on x axis + 1 of entities boundry
	temp_move.z = creation_point.z;
	
	trace_mode = IGNORE_ME + IGNORE_PASSABLE + IGNORE_PASSENTS + use_box;	//Ignore anything you can move through (you can change this if you don't want them to spawn there)
	stuck_yet = trace (creation_point, temp_move);
	
	if (stuck_yet != 0) { ent_remove(my); }	//if trace hit something entity is in something it can't move in
	
	if (stuck_yet == 0) 			//if trace didn't hit anything, entity isn't "in" anything, so create it
	{
		ent_remove(my);

		//define corresponding actions if you want them
		corresponding_actions(spawn_pointer.temp_create_num);		//define corresponding actions to each entity (at top of code 2nd function)

		//define one action to all of your entities
		//temp_ent_switch = ent_create (created_entity, creation_point, actor_walk_fight);	//corresponding_actions allows multiple functions for your entities, if you want only one, comment that function and its call in this function, and use this line
		
		global_count += 1;
		spawn_pointer._temp_local += 1;

		temp_ent_switch.pan = spawn_pointer.pan_angle;
		temp_ent_switch.tilt = spawn_pointer.tilt_angle;
		temp_ent_switch.roll = spawn_pointer.roll_angle;

		if (spawn_pointer._random_pan == on)
		{
			temp_ent_switch.pan = random(360);		//enitity changes pan from 0 to 359.99999 degrees
		}
		if (spawn_pointer._random_tilt == on)
		{
			temp_ent_switch.tilt = random(360);		//enitity changes tilt from 0 to 359.99999 degrees
		}
		if (spawn_pointer._random_roll == on)
		{
			temp_ent_switch.roll = random(360);		//enitity changes roll from 0 to 359.99999 degrees
		}
	}
}

function spawn(&creation_point)
{
	my.temp_create_num = int(random(my._amount_created)) + my._starting_ent;
	select_spawned(my.temp_create_num);			//top of code, 1st function
	while (created_entity == null)				//protect from an empty entity being spawned
	{
		my.temp_create_num = int(random(my._amount_created)) + my._starting_ent;
		select_spawned(my.temp_create_num);		//keep selecting random integers in array until found a valid entity	
	}

	ent_create (created_entity, creation_point, action_switch);		//input correct actor at top of code
}

function cylinder
{
	creation_point.x = ( (random(my._radius * 2)) - my._radius);		//if radius is 1, range = -1 to 1
	creation_maxrange.y = sqrt( abs((my._radius * my._radius) - (creation_point.x * creation_point.x)) );
	creation_point.y = ( (random(creation_maxrange.y * 2)) - creation_maxrange.y);
	creation_point.z = (random(my._height_length) - (my._height_length / 2));	//for entity being at center of shape
	
	//creation_point.z = random(my._height_length);				//for entity being at bottom center of shape
	
	if (my._x_axis == on)
	{
		axis_switch.x = creation_point.x;
		axis_switch.z = creation_point.z;
		creation_point.x = axis_switch.z;
		creation_point.z = axis_switch.x;
	}
	if (my._y_axis == on)
	{
		axis_switch.y = creation_point.y;
		axis_switch.z = creation_point.z;
		creation_point.y = axis_switch.z;
		creation_point.z = axis_switch.y;
	}
}

function circle_half
{
	creation_point.x = ( (random(my._radius * 2)) - my._radius);		//if radius is 1, range = -1 to 1
	creation_maxrange.y = sqrt( abs((my._radius * my._radius) - (creation_point.x * creation_point.x)) );
	creation_maxrange.z = sqrt( abs((my._radius * my._radius) - (creation_point.x * creation_point.x)) );
	creation_point.y = ( (random(creation_maxrange.y * 2)) - creation_maxrange.y);
	creation_point.z = ( (random(creation_maxrange.z)) - (my._radius / 2) );	//for entity being at center of shape
	
	//creation_point.z = (random(creation_maxrange.z));			//for entity being at bottom center of shape
}

function circle_full
{
	creation_point.x = ( (random(my._radius * 2)) - my._radius);		//if radius is 1, range = -1 to 1
	creation_maxrange.y = sqrt( abs((my._radius * my._radius) - (creation_point.x * creation_point.x)) );
	creation_maxrange.z = sqrt( abs((my._radius * my._radius) - (creation_point.x * creation_point.x)) );
	creation_point.y = ( (random(creation_maxrange.y * 2)) - creation_maxrange.y);
	creation_point.z = ( (random(creation_maxrange.z * 2)) - creation_maxrange.z);	//for entity being at center of shape
	
	//creation_point.z = ( (random(creation_maxrange.z));		//for entity being at bottom center of shape
}

function circle_plane
{
	creation_point.x = ( (random(my._radius * 2)) - my._radius);	//if radius is 1, range = -1 to 1
	creation_maxrange.y = sqrt( abs((my._radius * my._radius) - (creation_point.x * creation_point.x)) );
	creation_point.y = ((random(creation_maxrange.y * 2)) - creation_maxrange.y);
	creation_point.z = 0;					//entity is the z axis at center of shape
}

function square_full
{
	creation_point.x = ((random(my._base_length_x)) - my._base_length_x / 2);	//if side is 1, range = -1 to 1
	creation_point.y = ((random(my._base_length_y)) - my._base_length_y / 2);
	creation_point.z = ((random(my._height_length)) - my._height_length / 2);	//for entity being at center of shape
	
	//creation_point.z = (random(my._height_length));		//for entity being at bottom center of shape
}

function square_plane
{
	creation_point.x = ((random(my._base_length_x)) - my._base_length_x / 2);	//if side is 1, range = -1 to 1
	creation_point.y = ((random(my._base_length_y)) - my._base_length_y / 2);
	creation_point.z = 0;					//entity is the z axis at center of shape
}

function create_spawn_handle		//entities SKILLNUMBER = spawn_pointer._handle_ID
{
	spawnhandle_array[spawnhandle_counter] = handle(my);
	my._handle_id = spawnhandle_counter;
	spawnhandle_counter += 1;
}

function find_spawn_scan
{
	handle_ident = my._handle_id;
}

// use: _radius, _local_kill_limit, _height_length, _local_limit, _global_limit, pan_angle, tilt_angle, roll_angle, _spawn_delay, _starting_ent, _ending_ent
// use: _amount_created, spawn_state, _handle_id, _local_kills, _temp_global, _temp_local, temp_create_num
// use: _random_pan, _random_tilt, _random_roll, _ignore_global, _ignore_local, _x_axis, _y_axis, _go_limit_once
action spawn_cylinder
{
	if (my._radius != 0 && my._height_length != 0)		//if no value exhists in any needed spawn dimension, don't run
	{
		create_spawn_handle();

		my.enable_scan = on;		//makes spawner sensitive to scanning
		my.event = find_spawn_scan;

		my._temp_local = 0;
		my._temp_global = global_count;
		my._local_kills = 0;

		if (my._spawn_delay == 0) { my._spawn_delay = 1; }
		
		if (my._radius == 0) { my._radius = .001; }	//if user forgot to specify one of the dimensions, let the spawner make one entity
		if (my._height_length == 0) { my._height_length = .001; }

		if (my._global_limit > global_spawn_limit) 
		{
			global_spawn_limit = my._global_limit; 
		}
		else 
		{ 
			my._global_limit = global_spawn_limit; 
		}

		wait(1);		//let the other spawn's configure

		if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }

		if (my._ignore_local == on) { my._local_limit = 10; }		//see while statement
		if (my._ignore_global == on) { my._global_limit = 10; my._temp_global = 0; }

		if (my._starting_ent == 0) { my._starting_ent = 1; }
		if (my._ending_ent < my._starting_ent) { my._ending_ent = my._starting_ent; }

		my._amount_created = (my._ending_ent - my._starting_ent) + 1;	//amount of possibly different entities to be spawned

		my.spawn_state = spawn_start;

		while(1)
		{
			if (my._ignore_global == off) { my._global_limit = global_spawn_limit; }	//update global spawn limit
			
			while(my._temp_local < my._local_limit && my._temp_global < my._global_limit && my._local_kills < my._local_kill_limit && my.spawn_state == spawn_start)
			{
				cylinder();			//get random point
				creation_point.x += my.x;
				creation_point.y += my.y;
				creation_point.z += my.z;
	
				spawn_pointer = my;
				spawn(creation_point);		//create your entity at the random point
				wait(my._spawn_delay);
	
				if (my._ignore_local == on) { my._temp_local = 0; }			//ignore local counter and use global counter to govern if stoping
				if (my._ignore_global == on) { my._temp_global = 0; }			//ignore global counter and use local counter to govern if stoping
				if (my._ignore_global == off)
				{
					my._temp_global = global_count;
					my._global_limit = global_spawn_limit;	//make sure global_spawn_limit hasn't changed since last wait()
				}

				if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }
			}
			while(my._go_limit_once == on) { wait(1); }
			wait(1);
		}
	}
}

// use: _radius, _local_kill_limit, _local_limit, _global_limit, pan_angle, tilt_angle, roll_angle, _spawn_delay, _starting_ent, _ending_ent
// use: _amount_created, spawn_state, _handle_id, _local_kills, _temp_global, _temp_local, temp_create_num
// use: _random_pan, _random_tilt, _random_roll, _ignore_global, _ignore_local, _go_limit_once
action spawn_circle_half
{
	if (my._radius != 0)		//if no value exhists in any needed spawn dimension, don't run
	{
		create_spawn_handle();

		my.enable_scan = on;		//makes spawner sensitive to scanning
		my.event = find_spawn_scan;

		my._temp_local = 0;
		my._temp_global = global_count;
		my._local_kills = 0;
		
		if (my._spawn_delay == 0) { my._spawn_delay = 1; }

		if (my._global_limit > global_spawn_limit) 
		{
			global_spawn_limit = my._global_limit; 
		}
		else 
		{ 
			my._global_limit = global_spawn_limit; 
		}

		wait(1);		//let the other spawn's configure

		if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }

		if (my._ignore_local == on) { my._local_limit = 10; }		//see while statement
		if (my._ignore_global == on) { my._global_limit = 10; my._temp_global = 0; }

		if (my._starting_ent == 0) { my._starting_ent = 1; }
		if (my._ending_ent < my._starting_ent) { my._ending_ent = my._starting_ent; }

		my._amount_created = (my._ending_ent - my._starting_ent)  + 1;	//amount of possibly different entities to be spawned

		my.spawn_state = spawn_start;

		while(1)
		{
			if (my._ignore_global == off) { my._global_limit = global_spawn_limit; }	//update global spawn limit

			while(my._temp_local < my._local_limit && my._temp_global < my._global_limit && my._local_kills < my._local_kill_limit && my.spawn_state == spawn_start)
			{
				circle_half();			//get random point
				creation_point.x += my.x;
				creation_point.y += my.y;
				creation_point.z += my.z;

				spawn_pointer = my;
				spawn(creation_point);		//create your entity at the random point
				wait(my._spawn_delay);

				if (my._ignore_local == on) { my._temp_local = 0; }			//ignore local counter and use global counter to govern if stoping
				if (my._ignore_global == on) { my._temp_global = 0; }			//ignore global counter and use local counter to govern if stoping
				if (my._ignore_global == off)
				{
					my._temp_global = global_count;
					my._global_limit = global_spawn_limit;	//make sure global_spawn_limit hasn't changed since last wait()
				}

				if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }
			}
			while(my._go_limit_once == on) { wait(1); }
			wait(1);
		}
	}
}

// use: _radius, _local_kill_limit, _local_limit, _global_limit, pan_angle, tilt_angle, roll_angle, _spawn_delay, _starting_ent, _ending_ent
// use: _amount_created, spawn_state, _handle_id, _local_kills, _temp_global, _temp_local, temp_create_num
// use: _random_pan, _random_tilt, _random_roll, _ignore_global, _ignore_local, _go_limit_once
action spawn_circle_full
{
	if (my._radius != 0) 		//if no value exhists in any needed spawn dimension, don't run
	{
		create_spawn_handle();

		my.enable_scan = on;		//makes spawner sensitive to scanning
		my.event = find_spawn_scan;

		my._temp_local = 0;
		my._temp_global = global_count;
		my._local_kills = 0;
		
		if (my._spawn_delay == 0) { my._spawn_delay = 1; }

		if (my._global_limit > global_spawn_limit) 
		{
			global_spawn_limit = my._global_limit; 
		}
		else 
		{ 
			my._global_limit = global_spawn_limit; 
		}

		wait(1);		//let the other spawn's configure

		if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }

		if (my._ignore_local == on) { my._local_limit = 10; }		//see while statement
		if (my._ignore_global == on) { my._global_limit = 10; my._temp_global = 0; }

		if (my._starting_ent == 0) { my._starting_ent = 1; }
		if (my._ending_ent < my._starting_ent) { my._ending_ent = my._starting_ent; }

		my._amount_created = (my._ending_ent - my._starting_ent)  + 1;	//amount of possibly different entities to be spawned

		my.spawn_state = spawn_start;

		while(1)
		{
			if (my._ignore_global == off) { my._global_limit = global_spawn_limit; }	//update global spawn limit

			while(my._temp_local < my._local_limit && my._temp_global < my._global_limit && my._local_kills < my._local_kill_limit && my.spawn_state == spawn_start)
			{
				circle_full();			//get random point
				creation_point.x += my.x;
				creation_point.y += my.y;
				creation_point.z += my.z;

				spawn_pointer = my;
				spawn(creation_point);		//create your entity at the random point
				wait(my._spawn_delay);

				if (my._ignore_local == on) { my._temp_local = 0; }			//ignore local counter and use global counter to govern if stoping
				if (my._ignore_global == on) { my._temp_global = 0; }			//ignore global counter and use local counter to govern if stoping
				if (my._ignore_global == off)
				{
					my._temp_global = global_count;
					my._global_limit = global_spawn_limit;	//make sure global_spawn_limit hasn't changed since last wait()
				}

				if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }
			}
			while(my._go_limit_once == on) { wait(1); }
			wait(1);
		}
	}
}

// use: _radius, _local_kill_limit, _local_limit, _global_limit, pan_angle, tilt_angle, roll_angle, _spawn_delay, _starting_ent, _ending_ent
// use: _amount_created, spawn_state, _handle_id, _local_kills, _temp_global, _temp_local, temp_create_num
// use: _random_pan, _random_tilt, _random_roll, _ignore_global, _ignore_local, _go_limit_once
action spawn_circle_plane
{
	if (my._radius != 0) 		//if no value exhists in any needed spawn dimension, don't run
	{
		create_spawn_handle();

		my.enable_scan = on;		//makes spawner sensitive to scanning
		my.event = find_spawn_scan;

		my._temp_local = 0;
		my._temp_global = global_count;
		my._local_kills = 0;
		
		if (my._spawn_delay == 0) { my._spawn_delay = 1; }

		if (my._global_limit > global_spawn_limit) 
		{
			global_spawn_limit = my._global_limit; 
		}
		else 
		{ 
			my._global_limit = global_spawn_limit; 
		}

		wait(1);		//let the other spawn's configure

		if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }

		if (my._ignore_local == on) { my._local_limit = 10; }		//see while statement
		if (my._ignore_global == on) { my._global_limit = 10; my._temp_global = 0; }

		if (my._starting_ent == 0) { my._starting_ent = 1; }
		if (my._ending_ent < my._starting_ent) { my._ending_ent = my._starting_ent; }

		my._amount_created = (my._ending_ent - my._starting_ent)  + 1;	//amount of possibly different entities to be spawned

		my.spawn_state = spawn_start;

		while(1)
		{
			if (my._ignore_global == off) { my._global_limit = global_spawn_limit; }	//update global spawn limit

			while(my._temp_local < my._local_limit && my._temp_global < my._global_limit && my._local_kills < my._local_kill_limit && my.spawn_state == spawn_start)
			{
				circle_plane();			//get random point
				creation_point.x += my.x;
				creation_point.y += my.y;
				creation_point.z += my.z;

				spawn_pointer = my;
				spawn(creation_point);		//create your entity at the random point
				wait(my._spawn_delay);

				if (my._ignore_local == on) { my._temp_local = 0; }			//ignore local counter and use global counter to govern if stoping
				if (my._ignore_global == on) { my._temp_global = 0; }			//ignore global counter and use local counter to govern if stoping
				if (my._ignore_global == off)
				{
					my._temp_global = global_count;
					my._global_limit = global_spawn_limit;	//make sure global_spawn_limit hasn't changed since last wait()
				}

				if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }
			}
			while(my._go_limit_once == on) { wait(1); }
			wait(1);
		}
	}
}

// use: _height_length, _base_length_x, _base_length_y, _local_kill_limit, _local_limit, _global_limit, pan_angle, tilt_angle, roll_angle, _spawn_delay, _starting_ent, _ending_ent
// use: _amount_created, spawn_state, _handle_id, _local_kills, _temp_global, _temp_local, temp_create_num
// use: _random_pan, _random_tilt, _random_roll, _ignore_global, _ignore_local, _go_limit_once
action spawn_square_full
{
	if (my._height_length != 0 && my._base_length_x != 0 && my._base_length_y != 0)	//if no value exhists in any needed spawn dimension, don't run
	{
		create_spawn_handle();

		my.enable_scan = on;		//makes spawner sensitive to scanning
		my.event = find_spawn_scan;

		my._temp_local = 0;
		my._temp_global = global_count;
		my._local_kills = 0;
		
		if (my._spawn_delay == 0) { my._spawn_delay = 1; }

		if (my._height_length == 0) { my._height_length = .001; }	//if user forgot to specify one of the dimensions, let the spawner make one entity
		if (my._base_length_x == 0) { my._base_length_x = .001; }
		if (my._base_length_y == 0) { my._base_length_y = .001; }

		if (my._global_limit > global_spawn_limit) 
		{
			global_spawn_limit = my._global_limit; 
		}
		else 
		{ 
			my._global_limit = global_spawn_limit; 
		}

		wait(1);		//let the other spawn's configure

		if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }

		if (my._ignore_local == on) { my._local_limit = 10; }		//see while statement
		if (my._ignore_global == on) { my._global_limit = 10; my._temp_global = 0; }

		if (my._starting_ent == 0) { my._starting_ent = 1; }
		if (my._ending_ent < my._starting_ent) { my._ending_ent = my._starting_ent; }

		my._amount_created = (my._ending_ent - my._starting_ent)  + 1;	//amount of possibly different entities to be spawned

		my.spawn_state = spawn_start;

		while(1)
		{
			if (my._ignore_global == off) { my._global_limit = global_spawn_limit; }	//update global spawn limit

			while(my._temp_local < my._local_limit && my._temp_global < my._global_limit && my._local_kills < my._local_kill_limit && my.spawn_state == spawn_start)
			{
				square_full();			//get random point
				creation_point.x += my.x;
				creation_point.y += my.y;
				creation_point.z += my.z;

				spawn_pointer = my;
				spawn(creation_point);		//create your entity at the random point
				wait(my._spawn_delay);

				if (my._ignore_local == on) { my._temp_local = 0; }			//ignore local counter and use global counter to govern if stoping
				if (my._ignore_global == on) { my._temp_global = 0; }			//ignore global counter and use local counter to govern if stoping
				if (my._ignore_global == off)
				{
					my._temp_global = global_count;
					my._global_limit = global_spawn_limit;	//make sure global_spawn_limit hasn't changed since last wait()
				}

				if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }
			}
			while(my._go_limit_once == on) { wait(1); }
			wait(1);
		}
	}
}

// use: _base_length_x, _base_length_y, _local_kill_limit, _local_limit, _global_limit, pan_angle, tilt_angle, roll_angle, _spawn_delay, _starting_ent, _ending_ent
// use: _amount_created, spawn_state, _handle_id, _local_kills, _temp_global, _temp_local, temp_create_num
// use: _random_pan, _random_tilt, _random_roll, _ignore_global, _ignore_local, _go_limit_once
action spawn_square_plane
{
	if (my._base_length_x != 0 && my._base_length_y != 0) 		//if no value exhists in any needed spawn dimension, don't run
	{
		create_spawn_handle();

		my.enable_scan = on;		//makes spawner sensitive to scanning
		my.event = find_spawn_scan;

		my._temp_local = 0;
		my._temp_global = global_count;
		my._local_kills = 0;
		
		if (my._spawn_delay == 0) { my._spawn_delay = 1; }

		if (my._base_length_x == 0) { my._base_length_x = .001; }	//if user forgot to specify one of the dimensions, let the spawner make one entity
		if (my._base_length_y == 0) { my._base_length_y = .001; }

		if (my._global_limit > global_spawn_limit) 
		{
			global_spawn_limit = my._global_limit; 
		}
		else 
		{ 
			my._global_limit = global_spawn_limit; 
		}

		wait(1);		//let the other spawn's configure

		if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }

		if (my._ignore_local == on) { my._local_limit = 10; }		//see while statement
		if (my._ignore_global == on) { my._global_limit = 10; my._temp_global = 0; }

		if (my._starting_ent == 0) { my._starting_ent = 1; }
		if (my._ending_ent < my._starting_ent) { my._ending_ent = my._starting_ent; }

		my._amount_created = (my._ending_ent - my._starting_ent) + 1;	//amount of possibly different entities to be spawned

		my.spawn_state = spawn_start;

		while(1)
		{
			if (my._ignore_global == off) { my._global_limit = global_spawn_limit; }	//update global spawn limit

			while(my._temp_local < my._local_limit && my._temp_global < my._global_limit && my._local_kills < my._local_kill_limit && my.spawn_state == spawn_start)
			{
				square_plane();			//get random point
				creation_point.x += my.x;
				creation_point.y += my.y;
				creation_point.z += my.z;

				spawn_pointer = my;
				spawn(creation_point);		//create your entity at the random point
				wait(my._spawn_delay);

				if (my._ignore_local == on) { my._temp_local = 0; }			//ignore local counter and use global counter to govern if stoping
				if (my._ignore_global == on) { my._temp_global = 0; }			//ignore global counter and use local counter to govern if stoping
				if (my._ignore_global == off)
				{
					my._temp_global = global_count;
					my._global_limit = global_spawn_limit;	//make sure global_spawn_limit hasn't changed since last wait()
				}

				if (my._local_kill_limit == 0) { my._local_kill_limit = my._local_kills + 1; }
			}
			while(my._go_limit_once == on) { wait(1); }
			wait(1);
		}
	}
}
//to make the use on action spawn_square_plane work, this is here


function access_3dspawn(3d_spawner)
{
	this_spawn = ptr_for_handle(spawnhandle_array[3d_spawner]);
	return(this_spawn); 
}


function spawn_death(spawn_num, deaths)
{	
	access_3dspawn(spawn_num);
	
	if ( this_spawn._temp_local <= deaths ) { this_spawn._temp_local = 0; }
	if ( this_spawn._temp_local > deaths )  { this_spawn._temp_local -= deaths; }

	if ( global_count <= deaths ) { global_count = 0; }
	if ( global_count > deaths )  { global_count -= deaths; }

	this_spawn._local_kills += deaths;
}

/*
function attach_to_spawn
{
	//has to go at beggining of the actors function (before a wait() anyway)
	entities.SKILLNUMBER = spawn_pointer._handle_ID;

	//whenever you want to acess it
	your_entity = ptr_for_handle(spawnhandle_array[entities SKILLNUMBER]);
	//or 
	access_3dspawn(number);		//turns this_spawn (predefined entity pointer) into spawner who's number you've indicated, returns the spawner who's number you've indicated as well

	//death
	access_3dspawn(entities SKILLNUMBER);
	this_spawn._temp_local -= 1;
	this_spawn._local_kills += 1;

	//want to stop local for a bit
	access_3dspawn(entities SKILLNUMBER);
	this_spawn.spawn_state = spawn_stop;

	//want to re-start local for a bit
	access_3dspawn(entities SKILLNUMBER);
	this_spawn.spawn_state = spawn_start;

	//want to stop all of the spawners
	var temp_count = 0;
	while (temp_count <= max_num_of_spawners_in_level)
	{
	access_3dspawn(entities SKILLNUMBER);
	this_spawn.spawn_state = spawn_stop;
	}
	//and change spawn_stop to spawn_start for starting everything again

	//if you want to keep spawning until local limit is reached and then stop spawning forever (for this spawner)
	access_3dspawn(entities SKILLNUMBER);
	while(this_spawn._temp_local < this_spawn._local_limit) 	//waits until the number of entities hits the limit
	{ 
		wait(1); 
		access_3dspawn(entities SKILLNUMBER); 		//this_spawn is only valid for as long as access_3dspawn is called once, once called again, this_spawn is overwritten
	}
	this_spawn.spawn_state = spawn_stop;
	
}
Make local limit reach then stop a function, and make a new function of kill(spawn) where you give # and that action
 is finished (no longer run through while(1)), and perhaps remove(me) after that
*/